#ifndef HIPDEF_H
#define HIPDEF_H
#ifdef NAMD_HIP
#define __ldg *
#ifndef NAMD_CUDA
#define __align__ alignas
#define cudaGetDevice hipGetDevice
#define cudaGetDeviceCount hipGetDeviceCount
#define cudaSetDevice hipSetDevice
#define cudaSetDeviceFlags hipSetDeviceFlags
#define cudaDeviceReset hipDeviceReset
#define cudaDeviceMapHost hipDeviceMapHost
#define cudaDeviceProp hipDeviceProp_t
#define cudaGetDeviceProperties hipGetDeviceProperties
#define cudaDeviceGetStreamPriorityRange hipDeviceGetStreamPriorityRange
#define cudaStreamDefault hipStreamDefault
#define cudaStreamCreate hipStreamCreate
#define cudaStreamCreateWithPriority hipStreamCreateWithPriority
#define cudaStreamDestroy hipStreamDestroy
#define cudaStreamWaitEvent hipStreamWaitEvent
#define cudaStreamSynchronize hipStreamSynchronize
#define cudaStream_t hipStream_t
#define cudaDeviceCanAccessPeer hipDeviceCanAccessPeer
#define cudaDeviceEnablePeerAccess hipDeviceEnablePeerAccess
#define cudaComputeModeProhibited hipComputeModeProhibited
#define cudaComputeModeExclusive hipComputeModeExclusive
#define cudaResourceDesc hipResourceDesc
//Events
#define cudaEventCreate hipEventCreate
#define cudaEventQuery hipEventQuery
#define cudaEventRecord hipEventRecord
#define cudaEventDestroy hipEventDestroy
#define cudaEventCreateWithFlags hipEventCreateWithFlags
#define cudaEventDisableTiming hipEventDisableTiming
#define cudaEventSynchronize hipEventSynchronize
#define cudaEvent_t hipEvent_t
#define cudaError_t hipError_t
#define cudaGetLastError hipGetLastError
#define cudaGetErrorString hipGetErrorString
//Status definitions
#define cudaSuccess hipSuccess
#define cudaErrorNotReady hipErrorNotReady
#define cudaErrorSetOnActiveProcess hipErrorSetOnActiveProcess
//Textures
#define cudaTextureObject_t hipTextureObject_t
#define cudaAddressModeClamp hipAddressModeClamp
#define cudaFilterModePoint hipFilterModePoint
#define cudaFilterModeLinear hipFilterModeLinear
#define cudaCreateTextureObject hipCreateTextureObject
#define cudaBindTextureToArray hipBindTextureToArray
#define cudaBindTexture hipBindTexture
#define cudaDestroyTextureObject hipDestroyTextureObject
#define cudaArray hipArray
#define cudaArray_t hipArray_t
#define cudaChannelFormatDesc hipChannelFormatDesc
#define cudaChannelFormatKindFloat hipChannelFormatKindFloat
#define cudaResourceTypeArray hipResourceTypeArray
#define cudaTextureDesc hipTextureDesc
#define cudaResourceTypeLinear hipResourceTypeLinear
//Memory management
#define cudaHostAllocMapped hipHostMallocMapped
#define cudaHostAlloc hipHostMalloc
#define cudaMemset hipMemset
#define cudaMemsetAsync hipMemsetAsync
#define cudaHostAllocDefault hipHostMallocDefault
#define cudaFree hipFree
#define cudaFreeArray hipFreeArray
#define cudaFreeHost hipHostFree
#define cudaMalloc hipMalloc
#define cudaMallocArray hipMallocArray
#define cudaMallocHost hipHostMalloc
#define cudaMemcpy hipMemcpy
#define cudaMemcpyAsync hipMemcpyAsync
#define cudaMemcpyPeerAsync hipMemcpyPeerAsync
#define cudaMemcpyToArray hipMemcpyToArray
#define cudaMemcpyHostToDevice hipMemcpyHostToDevice
#define cudaMemcpyDeviceToHost hipMemcpyDeviceToHost
#define cudaMemcpyDeviceToDevice hipMemcpyDeviceToDevice
#define cudaMemcpyToSymbol hipMemcpyToSymbol
#define cudaMemcpy3DParms hipMemcpy3DParms
#define cudaReadModeElementType hipReadModeElementType
#define cudaHostGetDevicePointer hipHostGetDevicePointer
#define cudaSharedMemBankSizeEightByte hipSharedMemBankSizeEightByte
#define make_cudaPos make_hipPos
#define make_cudaPitchedPtr make_hipPitchedPtr
#define make_cudaExtent make_hipExtent
#endif
#endif
#endif
